﻿<?xml version='1.0' encoding='UTF-8'?>
<xsl:stylesheet
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns:msdndomain="http://msdn.microsoft.com/aboutmsdn/rss/domains"
	xmlns:msxsl="urn:schemas-microsoft-com:xslt"
	xmlns:user="foo"
	version="1.0"
>

	<xsl:include href="bds:/xsl/languageStrings.xsl" />

	<msxsl:script implements-prefix="user" language="JScript">
		<![CDATA[
			function replaceText(action, node) {
				str = action.text;
				node = node.nextNode();
				value = "";

				re = /(\[[A-Za-z0-9]+\])/g;
				while ((arr = re.exec(str)) != null)
				{
					try
					{
						source = arr[0].substr(1, arr[0].length - 2);

						selNodes = node.selectNodes(source);

						if (selNodes.length > 0)
						{
							value = selNodes[0].text;
						} else {
							value = "";
						}

						str = str.substr(0, arr.index) + value + str.substr(arr.lastIndex);
						re = /(\[[A-Za-z0-9]+\])/g;
					} catch(e) {
						return e.message;
					}
				}

				return str;
				// return action.text.replace(/%s/gi, node[0].selectSingleNode("link").text);
			}
			
			function checkAction(globalAction, localAction, node) {
				try {
					if (localAction.text != null) {
						return replaceText(localAction, node);
					} else {
						if (globalAction.length > 0) {
							if (globalAction[0].text.length > 0) {
								return replaceText(globalAction[0], node);
							} else {
								return node;
							}
						} else {
							return node;
						}
					}
				} catch(e) { return node; }
			}
		]]>
	</msxsl:script>

	<xsl:template match='*'>
		<table align="left">
			<tr>
				<td class="contentHeadline">
					<xsl:value-of select="title" />
					<span id="blogTitle"></span>
				</td>
			</tr>
		</table>

		<xsl:variable name="Action" select="action" />
		<xsl:if test="count(channel) &gt; 0">
			<table align="right">
				<tr>
					<td class="contentMenu" onmouseover="contentMenuExpand(this);" onmouseout="contentMenuCollapse(this);">
						<p><a class="titleActionLink"><xsl:value-of select="subTitle" /></a></p>
						<div class="contentMenuSubMenu">
							<table>
								<xsl:apply-templates select='channel'>
									<xsl:with-param name="Action"><xsl:value-of select="$Action" /></xsl:with-param>
								</xsl:apply-templates>
							</table>
						</div>
					</td>
				</tr>
			</table>
		</xsl:if>
	</xsl:template>

	<xsl:template match='channel'>
		<xsl:param name="Action" />
		<xsl:if test="count(title) &gt; 0">
			<tr><td class="contentMenuItem" onmouseover="contentMenuExpand(this);" onmouseout="contentMenuCollapse(this);">
				<p><xsl:value-of select="title" /></p>
				<div class="contentMenuSubMenu2">
					<table>
						<xsl:apply-templates select="item">
							<xsl:with-param name="GlobalAction"><xsl:value-of select="$Action" /></xsl:with-param>
						</xsl:apply-templates>
					</table>
				</div>
			</td></tr>
		</xsl:if>
		<xsl:if test="count(title) = 0">
			<xsl:apply-templates select="item">
				<xsl:with-param name="GlobalAction"><xsl:value-of select="$Action" /></xsl:with-param>
			</xsl:apply-templates>
		</xsl:if>
	</xsl:template>

	<xsl:template match='item'>
		<xsl:param name="GlobalAction" />
		<tr><td class="contentSubMenuItem">
			<a class="contentMenuItemLink">
				<xsl:attribute name="href"><xsl:value-of select="user:checkAction($GlobalAction, action, .)" /></xsl:attribute>
				<xsl:value-of select="title" />
			</a>
		</td></tr>
	</xsl:template>

</xsl:stylesheet>