﻿<?xml version='1.0' encoding='UTF-8'?>
<xsl:stylesheet
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns:msdndomain="http://msdn.microsoft.com/aboutmsdn/rss/domains"
	xmlns:msxsl="urn:schemas-microsoft-com:xslt"
	xmlns:user="foo"
	version="1.0"
>

	<xsl:include href="bds:/xsl/languageStrings.xsl" />

	<msxsl:script implements-prefix="user" language="JScript">
		<![CDATA[
			function replaceBackslash(path) {
				return path.replace(/\\/gi, '\\\\');
			}
			
			function removeExt(file) {
				return file.substr(0, file.lastIndexOf('.')) || file;
			}
		]]>
	</msxsl:script>
	<xsl:template match='*'>
		<xsl:apply-templates select='channel' />
	</xsl:template>

	<xsl:template match='channel'>
		<div class="menuBar">
			<div class="menuHeader">
				<span class="menuHeaderText"><xsl:value-of select="title" /></span>
			</div>
			<xsl:if test="count(group/file) &gt; 0">
				<div>
					<xsl:apply-templates select="group[count(file) &gt; 0]">
						<xsl:sort select="title" />
					</xsl:apply-templates>
				</div>
				<xsl:if test="count(action) &gt; 0">
					<ul class="menuBarAction"><xsl:apply-templates select="action" /></ul>
				</xsl:if>
			</xsl:if>
			<xsl:if test="count(group/file) = 0">
				<ul class="menuBarSelection">
					<li><xsl:value-of select="noFavoritesMsg" /></li>
				</ul>
			</xsl:if>
		</div>
	</xsl:template>

	<xsl:template match='group'>
		<div class="quickFav">
			<a href="javascript:void();" onmousedown="showFavoriteGroup(this);"><h2>
				<xsl:if test="(position() = 1) or (default = '1')">
					<xsl:attribute name="class">down</xsl:attribute>
				</xsl:if>
				<xsl:if test="(position() &gt; 1) and (default != '1')">
					<xsl:attribute name="class">up</xsl:attribute>
				</xsl:if>
				<xsl:value-of select="title" /></h2></a>
			<div>
				<xsl:if test="(position() &gt; 1) and (default != '1')">
					<xsl:attribute name="class">wuppdi</xsl:attribute>
				</xsl:if>
				<ul class="menuBarSelection">
					<xsl:apply-templates select='file'>
						<xsl:sort select="title" />
						<xsl:sort select="file" />
					</xsl:apply-templates>
				</ul>
			</div>
		</div>
	</xsl:template>

	<xsl:template match='file'>
		<li><a href="javascript:openFileLink('{user:replaceBackslash(normalize-space(file))}');" title="{fullTitle}"><xsl:value-of select="user:removeExt(normalize-space(title))" /></a></li>
	</xsl:template>

	<xsl:template match='action'>
		<li><a href="{link}" title="{fullTitle}"><xsl:value-of select="title" /></a></li>
	</xsl:template>

</xsl:stylesheet>