﻿<?xml version='1.0' encoding='UTF-8'?>
<xsl:stylesheet
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:dc="http://purl.org/dc/elements/1.1/"
	version="1.0"
>

	<xsl:include href="bds:/xsl/languageStrings.xsl" />

	<xsl:template match='/*'>
		<ul>
			<xsl:choose>
				<xsl:when test="count(settingsEx/updateInfo/cache/channel) &gt; 0">
					<xsl:apply-templates select='settingsEx/updateInfo/cache/channel/item'>
					</xsl:apply-templates>
				</xsl:when>
				<xsl:otherwise>
					<li>
						<div class="contentAreaHeadline">
							<xsl:value-of select="$error" />
						</div>
						<div class="contentAreaContent">
							<span>
								<xsl:value-of select="$rssFeedNotLoaded" />
							</span>
						</div>
					</li>
				</xsl:otherwise>
			</xsl:choose>
		</ul>
	</xsl:template>

	<xsl:template match='channel'>
		<xsl:choose>
			<xsl:when test="count(item) &gt; 0">
				<xsl:apply-templates select="item" />
			</xsl:when>
			<xsl:otherwise>
				<li>
					<div class="contentAreaHeadline">
						<xsl:value-of select="$error" />
					</div>
					<div class="contentAreaContent">
						<span>
							<xsl:value-of select="$rssFeedEmpty" />
						</span>
					</div>
				</li>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match='item'>
		<xsl:if test="position() &lt;= 10">
			<li>
				<div class="contentAreaHeadline">
					<xsl:choose>
						<xsl:when test="(link) != ''">
							<a href="{link}"><xsl:value-of select="title" /></a>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="title" />
						</xsl:otherwise>
					</xsl:choose>
				</div>
				<div class="contentAreaContent">
					<xsl:variable name="Desc" select="normalize-space(description)" />
					<span>
						<xsl:value-of select="$Desc" disable-output-escaping="yes" />
					</span>
				</div>
				<xsl:if test='pubDate != ""'>
					<div class="contentAreaSubline"><xsl:value-of select="$postedOn" />&#160;<xsl:value-of select="pubDate" />
					</div>
				</xsl:if>
			</li>
		</xsl:if>
	</xsl:template>

</xsl:stylesheet>
