﻿<?xml version='1.0' encoding='UTF-8'?>
<xsl:stylesheet
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns:msdndomain="http://msdn.microsoft.com/aboutmsdn/rss/domains"
	xmlns:msxsl="urn:schemas-microsoft-com:xslt"
	xmlns:user="foo"
	version="1.0"
>

	<xsl:include href="bds:/xsl/languageStrings.xsl" />

	<msxsl:script implements-prefix="user" language="JScript">
		<![CDATA[
			function cropFolders(path) {
				var maxPathLen = 60;
				var pathThreshold = 20;

				var res;
				var endPath;
				var pathParts;
				var len;
				var lenHalf;
				var i;

				res = '';
				if (path.slice(0, 2) == '\\\\') {
					res = '\\\\';
					path = path.slice(2);
				}
				if (path.length > maxPathLen) {
					pathParts = path.split('\\');
					len = pathParts.length;
					lenHalf = len / 2;
					endPath = '';
					i = 0;
					while ((res.length + endPath.length < maxPathLen - pathThreshold) && (i - 1 < lenHalf)) {
						endPath = '\\' + pathParts[len - i - 1] + endPath;
						if (res.length + endPath.length < maxPathLen - pathThreshold) {
							res += pathParts[i] + '\\';
						}
						i++;
					}
					res += '...' + endPath;
				} else {
					res += path;
				}
				return res;
			}

			function replaceBackslash(path) {
				return path.replace(/\\/gi, '\\\\');
			}
		]]>
	</msxsl:script>

	<xsl:template match='/*'>
		<xsl:apply-templates select='channel/group[count(file) &gt; 0]'>
			<xsl:sort select="title" />
		</xsl:apply-templates>
	</xsl:template>

	<xsl:template match='group'>
		<div>
			<a href="javascript:void();" onmousedown="showFavoriteGroup(this);"><h2>
				<xsl:if test="(position() = 1) or (default = '1')">
					<xsl:attribute name="class">down</xsl:attribute>
				</xsl:if>
				<xsl:if test="(position() &gt; 1) and (default != '1')">
					<xsl:attribute name="class">up</xsl:attribute>
				</xsl:if>
				<xsl:value-of select="title" />
			</h2></a>
			<div>
				<xsl:if test="(position() &gt; 1) and (default != '1')">
					<xsl:attribute name="class">wuppdi</xsl:attribute>
				</xsl:if>
				<xsl:apply-templates select='file'>
					<xsl:sort select="title" />
					<xsl:sort select="file" />
				</xsl:apply-templates>
			</div>
		</div>
	</xsl:template>

	<xsl:template match='file'>
		<div class="contentAreaHeadline">
			<a class="toolLink" href="javascript:openFileLink('{user:replaceBackslash(normalize-space(file))}');" title="{fullTitle}"><xsl:apply-templates select='personality' /><xsl:value-of select="title" /></a>
		</div>
		<div class="contentAreaContent">
			<xsl:value-of select="user:cropFolders(normalize-space(file))" />
		</div>
		<div class="contentAreaSubline">
			<xsl:choose>
				<xsl:when test="lastChange != 'FNF'">
					<xsl:value-of select="$lastChange" />&#160;<xsl:value-of select="lastChange" />
				</xsl:when>
				<xsl:otherwise>
					<span class="error"><xsl:value-of select="$fileNotFound" /></span>
				</xsl:otherwise>
			</xsl:choose>
		</div>
	</xsl:template>

	<xsl:template match='personality'>
		<xsl:choose>
			<xsl:when test=". = 1">
				<img src='bds:/Images/project_group.gif' width='16' height='16' style='border: 0; margin-right: 5px;' />
			</xsl:when>
			<xsl:when test=". = 2">
				<img src='bds:/Images/project_d32.png' width='16' height='16' style='border: 0; margin-right: 5px;' />
			</xsl:when>
			<xsl:when test=". = 3">
				<img src='bds:/Images/project_dnet.gif' width='16' height='16' style='border: 0; margin-right: 5px;' />
			</xsl:when>
			<xsl:when test=". = 4">
				<img src='bds:/Images/project_cs.gif' width='16' height='16' style='border: 0; margin-right: 5px;' />
			</xsl:when>
			<xsl:when test=". = 5">
				<img src='bds:/Images/project_vb.gif' width='16' height='16' style='border: 0; margin-right: 5px;' />
			</xsl:when>
			<xsl:when test=". = 6">
				<img src='bds:/Images/project_cpp.png' width='16' height='16' style='border: 0; margin-right: 5px;' />
			</xsl:when>
			<xsl:when test=". = 7">
				<img src='bds:/Images/project_design.gif' width='16' height='16' style='border: 0; margin-right: 5px;' />
			</xsl:when>
			<xsl:otherwise>
				<img src='bds:/Images/project.gif' width='16' height='16' style='border: 0; margin-right: 5px;' />
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

</xsl:stylesheet>
