﻿<?xml version='1.0' encoding='UTF-8'?>
<xsl:stylesheet
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns:msdndomain="http://msdn.microsoft.com/aboutmsdn/rss/domains"
	xmlns:msxsl="urn:schemas-microsoft-com:xslt"
	xmlns:user="foo"
	version="1.0"
>

	<xsl:output method="html"/>

	<xsl:include href="bds:/xsl/languageStrings.xsl" />

	<msxsl:script implements-prefix="user" language="JScript">
		<![CDATA[
			function fdt(dtString)
			{
				try
				{
					var date;
					var dts;
					
					dts = dtString.item(0).text;
					date = new Date(dts)
					if (date.toLocaleDateString().toLowerCase() != "nan")
					{
						return date.toLocaleDateString();
					} else {
						date = new Date();
						date.setYear(dts.slice(0, 4));
						date.setMonth(dts.slice(5, 7) -1);
						date.setDate(dts.slice(8, 10));
						// if (dts.slice(10, 11).toLowerCase() == 't') {
							// date.setHours(dts.slice(11, 13));
							// date.setMinutes(dts.slice(14, 16));
							// date.setSeconds(dts.slice(17, 19));
						// }
						return date.toLocaleDateString();
					}
				} catch(e) {
					return dts;
				}
			}

			function removeSpecialTags(data)
			{
				data = data.replace(/(<\/p[\s]*>)|(<li[^>]*>)/gi, "<br \/>");
				data = data.replace(/(<(?!(br|a|code|pre|wpLine|\/))[^>]*>)/gi, "");
				data = data.replace(/(<\/(?!(a|code|pre|wpLine))[^>]*>)/gi, "");

				data = data.replace(/<br[^>]*>[\s]*<br[^>]*>/gi, "<br \/>");
				data = data.replace(/<br[^>]*>[\s]*<br[^>]*>/gi, "<br \/>");
				data = data.replace(/<br[^>]*>[\s]*<br[^>]*>/gi, "<br \/>");
				data = data.replace(/<br[^>]*>[\s]*<br[^>]*>/gi, "<br \/>");
				data = data.replace(/<br[^>]*>[\s]*<br[^>]*>/gi, "<br \/>");
				data = data.replace(/<wpLine>/gi, "<div class='wpLine' \/>");

				return data;
				// debug code, comment-out previous line to check up the results
				return data.replace(/&/gi, "&amp;").replace(/</gi, "&lt;").replace(/>/gi, "&gt;");
			}
			function removeSize(data)
			{
            	 return data.replace(/<(font)[^>]*>/gi,"").replace(/<(\/font)>/gi, "");
			}
			function checkTag(tag, res)
			{
				var idxO, idxC;
				
				idxO = res.indexOf('<' + tag);
				while (idxO >= 0)
				{
					idxC = res.indexOf(idxO, '</' + tag);
					if (idxC < 0)
					{
						res += '</' + tag + '> ';
					}
					idxO = res.indexOf(idxO + 1, '<' + tag);
				}
				return res;
			}
			function checkTags(res)
			{
				res = checkTag('a', res);
				res = checkTag('A', res);
				res = checkTag('code', res);
				res = checkTag('CODE', res);
				res = checkTag('pre', res);
				res = checkTag('PRE', res);
				
				return res;
			}
			function trimNextWord(text)
			{
				var idx;
				var nIdx;
				var start;
				var substr;

				substr = text.substr(500);
				idx = substr.indexOf('<');
				if (idx >= 0 && substr.charAt(idx + 1) == '/')
				{
					start = text.substr(0, 500 + idx);
					substr = text.substr(500 + idx);
					return checkTags(start + substr.substr(0, substr.indexOf('>') + 1));
				} else {
					start = text.substr(0, 500);
					idx = substr.indexOf('.') + 1;
					nIdx = substr.indexOf('<'); if (nIdx >= 0 && nIdx < idx) idx = nIdx;
					nIdx = substr.indexOf(')'); if (nIdx >= 0 && nIdx < idx) idx = nIdx;
					return checkTags(text.substr(0, 500 + idx));
				}
			}
		]]>
	</msxsl:script>

	<xsl:template match='/*'>
		<ul>
			<xsl:choose>
				<xsl:when test="count(channel) &gt; 0">
					<xsl:apply-templates select='channel' />
				</xsl:when>
				<xsl:otherwise>
					<li>
						<div class="contentAreaHeadline">
							<xsl:value-of select="$error" />
						</div>
						<div class="contentAreaContent">
							<span>
								<xsl:value-of select="$rssFeedNotLoaded" />
							</span>
						</div>
					</li>
				</xsl:otherwise>
			</xsl:choose>
		</ul>
	</xsl:template>

	<xsl:template match='channel'>
		<xsl:choose>
			<xsl:when test="count(item) &gt; 0">
				<xsl:apply-templates select="item" />
			</xsl:when>
			<xsl:otherwise>
				<li>
					<div class="contentAreaHeadline">
						<xsl:value-of select="$error" />
					</div>
					<div class="contentAreaContent">
						<span>
							<xsl:value-of select="$rssFeedEmpty" />
						</span>
					</div>
				</li>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match='item'>
		<xsl:if test="position() &lt;= 10 or @ignoreSize = '1'">
			<li>
				<div class="contentAreaHeadline">
					<xsl:choose>
						<xsl:when test="(link) != ''">
							<a href="{link}"><xsl:value-of select="title" /></a>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="title" />
						</xsl:otherwise>
					</xsl:choose>
				</div>
				<div class="contentAreaContent">
					<xsl:variable name="Desc" select="user:removeSize(user:removeSpecialTags(normalize-space(description)))" />
					<xsl:variable name="Length" select="string-length($Desc)" />
					<span class="inlineLinks">
						<xsl:choose>
							<xsl:when test="$Length &lt;= 500 or @ignoreSize = '1'">
								<xsl:value-of select="$Desc" disable-output-escaping="yes" />
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="user:trimNextWord($Desc)" disable-output-escaping="yes" />
								<helper value="" otherValue=''/>
								[<a class="title" href="{link}"><xsl:value-of select="$readMore" /></a>]
							</xsl:otherwise>
						</xsl:choose>
					</span>
				</div>
				<xsl:if test='pubDate != ""'>
					<div class="contentAreaSubline inlineLinks comments"><xsl:value-of select="$postedOn" />&#160;<xsl:value-of select="user:fdt(pubDate)" />
						<xsl:if test='comments != ""'>
							- <a class="comments" href="{comments}"><xsl:value-of select="$readComments" /></a>
						</xsl:if>
					</div>
				</xsl:if>
			</li>
		</xsl:if>
	</xsl:template>

</xsl:stylesheet>