﻿<?xml version='1.0' encoding='UTF-8'?>
<xsl:stylesheet
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns:msdndomain="http://msdn.microsoft.com/aboutmsdn/rss/domains"
	xmlns:ms="urn:schemas-microsoft-com:xslt"
	xmlns:msxsl="urn:schemas-microsoft-com:xslt"
	xmlns:dt="urn:schemas-microsoft-com:datatypes"
	xmlns:user="foo"
	version="1.0"
>

	<xsl:include href="bds:/xsl/languageStrings.xsl" />

	<xsl:template match='*'>
		<xsl:apply-templates select='form' />
	</xsl:template>

	<xsl:template match='form'>
		<form action="{action}" enctype="text/plain">
			<ul>
				<xsl:apply-templates select="input" />
			</ul>
		</form>
	</xsl:template>

	<xsl:template match='input'>
		<xsl:choose>
			<xsl:when test="(type) = 'hidden'">
				<input type="Hidden" id="xSearch_{id}" value="{value}" />
			</xsl:when>
			<xsl:otherwise>
				<li>
					<div class="contentAreaHeadline">
						<xsl:value-of select="label" />
					</div>
					<div class="contentAreaContent">
						<xsl:choose>
							<xsl:when test="(type) = 'content'">
								<xsl:for-each select="(text)">
									<xsl:value-of select="." /><br />
								</xsl:for-each>
							</xsl:when>
							<xsl:when test="(type) = 'div'">
								<div id="xForm_{id}">
									<xsl:if test="(class)">
										<xsl:attribute name="class"><xsl:value-of select="class" /></xsl:attribute>
									</xsl:if>
									&#160;
								</div>
							</xsl:when>
							<xsl:when test="(type) = 'text'">
								<input type="Text" id="xForm_{id}" value="{value}" style="width:250px;">
									<xsl:if test="(class)">
										<xsl:attribute name="class"><xsl:value-of select="class" /></xsl:attribute>
									</xsl:if>
								</input>
							</xsl:when>
							<xsl:when test="(type) = 'textarea'">
								<textarea id="xForm_{id}" cols="{cols}" rows="{rows}">
									<xsl:if test="(class)">
										<xsl:attribute name="class"><xsl:value-of select="class" /></xsl:attribute>
									</xsl:if>
									<xsl:value-of select="value" />
								</textarea>
							</xsl:when>
							<xsl:when test="(type) = 'select'">
								<select id="xForm_{id}" style="width:250px;" >
									<xsl:if test="(class)">
										<xsl:attribute name="class"><xsl:value-of select="class" /></xsl:attribute>
									</xsl:if>
									<xsl:apply-templates select='options/option' mode="select" />
								</select>
							</xsl:when>
							<xsl:when test="(type) = 'submit'">
								<input type="Submit" value="{submit}">
									<xsl:if test="(class)">
										<xsl:attribute name="class"><xsl:value-of select="class" /></xsl:attribute>
									</xsl:if>
								</input>
								&#160;
								<input type="Reset" value="{reset}">
									<xsl:if test="(class)">
										<xsl:attribute name="class"><xsl:value-of select="class" /></xsl:attribute>
									</xsl:if>
								</input>
							</xsl:when>
						</xsl:choose>
						<xsl:if test="(action)">
							<br />
							<a href="{action}" class="xFormActionLink"><xsl:value-of select="actionText" /></a>
						</xsl:if>
						<xsl:if test="spacer">
							<div style="padding: 0; margin: 0; border: 0; height: {spacer}px;" />
						</xsl:if>
					</div>
				</li>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match='option' mode='select'>
		<option value="{value}"><xsl:value-of select="label" /></option>
	</xsl:template>

</xsl:stylesheet>