﻿<?xml version='1.0' encoding='UTF-8'?>
<xsl:stylesheet
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns:msdndomain="http://msdn.microsoft.com/aboutmsdn/rss/domains"
	xmlns:msxsl="urn:schemas-microsoft-com:xslt"
	xmlns:user="foo"
	version="1.0"
>

	<xsl:include href="bds:/xsl/languageStrings.xsl" />

	<msxsl:script implements-prefix="user" language="JScript">
		<![CDATA[
			function cropFolders(path) {
				var maxPathLen = 60;
				var pathThreshold = 20;

				var res;
				var endPath;
				var pathParts;
				var len;
				var lenHalf;
				var i;

				res = '';
				if (path.slice(0, 2) == '\\\\') {
					res = '\\\\';
					path = path.slice(2);
				}
				if (path.length > maxPathLen) {
					pathParts = path.split('\\');
					len = pathParts.length;
					lenHalf = len / 2;
					endPath = '';
					i = 0;
					while ((res.length + endPath.length < maxPathLen - pathThreshold) && (i - 1 < lenHalf)) {
						endPath = '\\' + pathParts[len - i - 1] + endPath;
						if (res.length + endPath.length < maxPathLen - pathThreshold) {
							res += pathParts[i] + '\\';
						}
						i++;
					}
					res += '...' + endPath;
				} else {
					res += path;
				}
				return res;
			}

			function replaceBackslash(path) {
				return path.replace(/\\/gi, '\\\\');
			}
		]]>
	</msxsl:script>

	<xsl:template match='/*'>
		<xsl:apply-templates select='channel/file' />
	</xsl:template>

	<xsl:template match='file'>
		<div class="contentAreaHeadline">
			<a class="toolLink" href="javascript:openFileLink('{user:replaceBackslash(normalize-space(file))}');" title="{fullTitle}"><xsl:apply-templates select='personality' /><xsl:value-of select="title" /></a>
			<xsl:if test="count(makeFavorite) &gt; 0">
				&#160;<a href="javascript:makeProjectFavorite(this, '{user:replaceBackslash(normalize-space(file))}');" style="visibility: visible;" class="contentAreaHeadlineSubLink"><xsl:value-of select="$makeFavorite" /></a>
			</xsl:if>
		</div>
		<div class="contentAreaContent">
			<table class="projectHintTable">
				<tr class="projectHintRow">
					<td class="projectHintId"><xsl:value-of select="$projectLocation" /></td>
					<td class="projectHintContent"><xsl:value-of disable-output-escaping="yes" select="user:cropFolders(normalize-space(file))" /></td>
				</tr>
				<tr class="projectHintRow">
					<td class="projectHintId"><xsl:value-of select="$projectPersonality" /></td>
					<td class="projectHintContent"><xsl:apply-templates select='personalityName' /></td>
				</tr>
				<xsl:if test="(personalityName) = 1">
					<tr class="projectHintRow">
						<td class="projectHintId"><xsl:value-of select="$projectContains" /></td>
						<td class="projectHintContent"><xsl:apply-templates select='Projects' /></td>
					</tr>
				</xsl:if>
				<xsl:if test="(AdditionalProjectCount) > 0">
					<tr class="projectHintRow">
						<td class="projectHintId"></td>
						<td class="projectHintContent"><xsl:apply-templates select='AdditionalProjectCount' /></td>
					</tr>
				</xsl:if>
			</table>
		</div>
		<div class="contentAreaSubline">
		</div>
	</xsl:template>

	<xsl:template match='personality'>
		<xsl:choose>
			<xsl:when test=". = 1">
				<img src='bds:/Images/project_group.gif' width='16' height='16' style='border: 0; margin-right: 5px;' />
			</xsl:when>
			<xsl:when test=". = 2">
				<img src='bds:/Images/project_d32.png' width='16' height='16' style='border: 0; margin-right: 5px;' />
			</xsl:when>
			<xsl:when test=". = 3">
				<img src='bds:/Images/project_dnet.gif' width='16' height='16' style='border: 0; margin-right: 5px;' />
			</xsl:when>
			<xsl:when test=". = 4">
				<img src='bds:/Images/project_cs.gif' width='16' height='16' style='border: 0; margin-right: 5px;' />
			</xsl:when>
			<xsl:when test=". = 5">
				<img src='bds:/Images/project_vb.gif' width='16' height='16' style='border: 0; margin-right: 5px;' />
			</xsl:when>
			<xsl:when test=". = 6">
				<img src='bds:/Images/project_cpp.png' width='16' height='16' style='border: 0; margin-right: 5px;' />
			</xsl:when>
			<xsl:when test=". = 7">
				<img src='bds:/Images/project_design.gif' width='16' height='16' style='border: 0; margin-right: 5px;' />
			</xsl:when>
			<xsl:otherwise>
				<img src='bds:/Images/project.gif' width='16' height='16' style='border: 0; margin-right: 5px;' />
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match='personalityName'>
		<xsl:choose>
			<xsl:when test=". = 1">
				<xsl:value-of select="$projectGroup" />
			</xsl:when>
			<xsl:when test=". = 2">
				<xsl:value-of select="$projectDWin32" />
			</xsl:when>
			<xsl:when test=". = 3">
				<xsl:value-of select="$projectDNet" />
			</xsl:when>
			<xsl:when test=". = 4">
				<xsl:value-of select="$projectCS" />
			</xsl:when>
			<xsl:when test=". = 5">
				<xsl:value-of select="$projectVB" />
			</xsl:when>
			<xsl:when test=". = 6">
				<xsl:value-of select="$projectCPP" />
			</xsl:when>
			<xsl:when test=". = 7">
				<xsl:value-of select="$projectDesigner" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$projectOther" />
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match='Projects'>
		<xsl:value-of disable-output-escaping="yes" select="user:cropFolders(normalize-space(.))" />
		<br />
	</xsl:template>

	<xsl:template match='AdditionalProjectCount'>
		<xsl:value-of select="$projectAdditionalCountPrefix" /><xsl:value-of select="." /><xsl:value-of select="$projectAdditionalCountPostfix" />
		<br />
	</xsl:template>


</xsl:stylesheet>
